import { Stream, Listener, Subscription } from 'xstream'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface ObservableComponent {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Stream<T>
    fromEvent: <T>(
        eventName: string,
        valueTransformer?: (val: any) => T
    ) => Stream<T>
    mount: Stream<any>
    unmount: Stream<any>
    pushEvent: PushEvent
    useEvent: <T>(
        eventName: string,
        seedValue?: T
    ) => [Stream<T>, (val: T) => any]
}
export declare type Aperture<P, E, C = any> = (
    initialProps: P,
    initialContext: C
) => (component: ObservableComponent) => Stream<E>
export declare const subscribeToSink: <T>(
    sink: Stream<T>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const createComponent: <P>(
    instance: any,
    dataObservable: any,
    pushEvent: PushEvent
) => ObservableComponent
